#include "divide.h"

uint32_t approx_divide(uint32_t a, uint32_t b) {
    int8_t c;

    while (b > 0xFFFF) {
        a >>= 8;
        b >>= 8;
    }
    while (b > 0xFF) {
        a >>= 1;
        b >>= 1;
    }
    c = 16;
    while (a > 0xFFFF) {
        a >>= 1;
        c--;
    }
    return (a * divide_table[b]) >> c;
}
