#include <stdint.h>
#ifdef HOST
void uart_puts(char *);

#else
#include <libavr/flash.h>
#define uart_puts(x) uart_putsf(PSTR(x))
void uart_putsf(faddr_t);
#endif

uint8_t uart_getc(void);
void uart_putc(uint8_t);
void uart_puti(int32_t);
void uart_putd(int32_t);
void uart_report(uint8_t);
